summaryrefslogtreecommitdiff
path: root/t/t0005-signals.sh
diff options
context:
space:
mode:
Diffstat (limited to 't/t0005-signals.sh')
-rwxr-xr-xt/t0005-signals.sh23
1 files changed, 12 insertions, 11 deletions
diff --git a/t/t0005-signals.sh b/t/t0005-signals.sh
index aeea50c633..46042f1f13 100755
--- a/t/t0005-signals.sh
+++ b/t/t0005-signals.sh
@@ -10,13 +10,14 @@ one
EOF
test_expect_success 'sigchain works' '
- test-sigchain >actual
- case "$?" in
- 143) true ;; # POSIX w/ SIGTERM=15
- 271) true ;; # ksh w/ SIGTERM=15
- 3) true ;; # Windows
- *) false ;;
- esac &&
+ { test-sigchain >actual; ret=$?; } &&
+ {
+ # Signal death by raise() on Windows acts like exit(3),
+ # regardless of the signal number. So we must allow that
+ # as well as the normal signal check.
+ test_match_signal 15 "$ret" ||
+ test "$ret" = 3
+ } &&
test_cmp expect actual
'
@@ -40,13 +41,13 @@ test_expect_success 'create blob' '
'
test_expect_success !MINGW 'a constipated git dies with SIGPIPE' '
- OUT=$( ((large_git; echo $? 1>&3) | :) 3>&1 )
- test "$OUT" -eq 141
+ OUT=$( ((large_git; echo $? 1>&3) | :) 3>&1 ) &&
+ test_match_signal 13 "$OUT"
'
test_expect_success !MINGW 'a constipated git dies with SIGPIPE even if parent ignores it' '
- OUT=$( ((trap "" PIPE; large_git; echo $? 1>&3) | :) 3>&1 )
- test "$OUT" -eq 141
+ OUT=$( ((trap "" PIPE; large_git; echo $? 1>&3) | :) 3>&1 ) &&
+ test_match_signal 13 "$OUT"
'
test_done